pro BSPCAR,TETA,PHI,BR,BTET,BPHI,BX,BY,BZ

;C
;C   CALCULATES CARTESIAN FIELD COMPONENTS FROM SPHERICAL ONES
;C-----INPUT:   TETA,PHI - SPHERICAL ANGLES OF THE POINT IN RADIANS
;C              BR,BTET,BPHI -  SPHERICAL COMPONENTS OF THE FIELD
;C-----OUTPUT:  BX,BY,BZ - CARTESIAN COMPONENTS OF THE FIELD
;C
;C   LAST MOFIFICATION:  JAN 5 2001 (NO ESSENTIAL CHANGES, BUT
;C                        SOME REDUNDANT STATEMENTS TAKEN OUT)
;C
;C   WRITTEN BY:  N. A. TSYGANENKO
;C
      S=SIN(TETA)
      C=COS(TETA)
      SF=SIN(PHI)
      CF=COS(PHI)
      BE=BR*S+BTET*C
      BX=BE*CF-BPHI*SF
      BY=BE*SF+BPHI*CF
      BZ=BR*C-BTET*S


      END
