GEOMAG,XGEO,YGEO,ZGEO,XMAG,YMAG,ZMAG,J,IYR
;C
;C    CONVERTS GEOGRAPHIC (GEO) TO DIPOLE (MAG) COORDINATES OR VICA VERSA.
;C    IYR IS YEAR NUMBER (FOUR DIGITS).
;C
;C                           J &Gt  0                J &Lt 0
;C-----INPUT:  J,XGEO,YGEO,ZGEO,IYR   J,XMAG,YMAG,ZMAG,IYR
;C-----OUTPUT:    XMAG,YMAG,ZMAG        XGEO,YGEO,ZGEO
;C
;C   OTHER SUBROUTINES CALLED BY THIS ONE:  RECALC
;C
;C   LAST MOFIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES, BUT
;C                         SOME REDUNDANT STATEMENTS TAKEN OUT)
;C
;C   WRITTEN BY:  N. A. TSYGANENKO
;C

     COMMON GEOPACK, ST0,CT0,SL0,CL0,CTCL,STCL,CTSL,STSL,SFI,CFI,SPS,$
       CPS,SHI,CHI,HI,PSI,XMUT,A11,A21,A31,A12,A22,A32,A13,A23,A33,DS3,$
       K,IY,CGST,SGST
;
;
;      COMMON /GEOPACK/ ST0,CT0,SL0,CL0,CTCL,STCL,CTSL,STSL,AB(19),
;     * K,IY,BB(8)

      II=1
;C
      IF  IYR EQ II then GOTO, level1
      II=IYR
      RECALC,II,0,25,0,0
  level1:
      IF J LT 0 then GOTO, leve2
      XMAG=XGEO*CTCL+YGEO*CTSL-ZGEO*ST0
      YMAG=YGEO*CL0-XGEO*SL0
      ZMAG=XGEO*STCL+YGEO*STSL+ZGEO*CT0
      goto, levele
  level2:
      XGEO=XMAG*CTCL-YMAG*SL0+ZMAG*STCL
      YGEO=XMAG*CTSL+YMAG*CL0+ZMAG*STSL
      ZGEO=ZMAG*CT0-XMAG*ST0
  levele:
      RETURN
      END
c
